#
# u2df08.rb
#
# $Id: u2df08.rb,v 1.1 2000/11/22 14:35:58 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


nx = 19
ny = 19
xmin = 0
xmax = 360
dx1 = 20
dx2 = 60
ymin = -90
ymax = +90
dy1 = 10
dy2 = 30
drad = PI/180
dz = 0.05

p = NArray.sfloat(nx, ny)
u = NArray.sfloat(nx, ny)
v = NArray.sfloat(nx, ny)

#-- data ---
for j in 0..ny-1
  for i in 0..nx-1
    alon = (xmin + (xmax-xmin)*i/(nx-1)) * drad
    alat = (ymin + (ymax-ymin)*j/(ny-1)) * drad
    slat = sin(alat)
    p[i,j] = cos(alon) * (1-slat**2) * sin(2*PI*slat) + dz
  end
end

rmiss = glrget('RMISS')
gllset('LMISS', true)

for j in 0..ny-1
  for i in 0..nx-1
    if (j == 0 || j == ny-1)
      u[i,j]=rmiss
      v[i,j]=rmiss
    else
      u[i,j] = p[i,j-1] - p[i,j+1]
      v[i,j] = p[imod(i+1,nx-1),j] - p[imod(i-1,nx-1),j]
    end
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

grswnd(xmin, xmax, ymin, ymax)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uxaxdv('B', dx1, dx2)
uxaxdv('T', dx1, dx2)
uxsttl('B', 'LONGITUDE', 0.0)

uyaxdv('L', dy1, dy2)
uyaxdv('R', dy1, dy2)
uysttl('L', 'LATITUDE', 0.0)

udrset('RSIZEL', 0.015)
udrset('RSIZET', 0.015)
udcntr(p)

ugrset('RSIZET', 0.015)
uglset('LNRMAL', false)
ugrset('XFACT1', 0.025)
ugrset('YFACT1', 0.050)
uglset('LUNIT', true)
ugsut('X', 'U')
ugsut('Y', 'V')
ugrset('VXUNIT', 0.05)
ugrset('VYUNIT', 0.10)
ugvect(u, v)

grcls

