#
# miss2.rb
#   $Id: miss2.rb,v 1.1 2000/11/18 19:03:40 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math


nx = 37
ny = 37
xmin = 0
xmax = 360
ymin = -90
ymax = 90
drad = PI/180
p = NArray.sfloat(nx, ny)

rmiss = glrget('RMISS')
gllset('LMISS', true)

#-- data ---
for j in 0..ny-1
  for i in 0..nx-1
    alon = (xmin + (xmax-xmin)*i/(nx-1)) * drad
    alat = (ymin + (ymax-ymin)*j/(ny-1)) * drad
    slat = sin(alat)
    p[i,j] = 3*sqrt(1-slat**2)*slat*cos(alon) - 0.5*(3*slat**2-1)
    if ( i == 5 && j == 5 )
      p[i,j] = rmiss
    end
    if ( ( 7 <= i && i <= 23) && j == 29 )
      p[i,j] = rmiss
    end
    if( (21 <= i && i <= 29) && (11 <= j && j <= 19))
      p[i,j] = rmiss
    end
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

grswnd(xmin, xmax, ymin, ymax)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uetone(p)
usdaxs
udcntr(p)

grcls

